diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
index 3083b182f..fafc504cd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
@@ -8,6 +8,7 @@ import net.minecraft.core.world.biome.data.BiomeRangeMap;
 import net.minecraft.core.world.noise.FractalNoise2D;
 import net.minecraft.core.world.noise.FractalNoise3D;
 import net.minecraft.core.world.noise.SimplexNoise;
+import net.minecraft.core.world.noise.WorleyNoise;
 import net.minecraft.core.world.type.WorldType;
 
 import java.util.Set;
@@ -47,10 +48,10 @@ public final class BiomeProviderOverworld
     {
         this.worldType = worldType;
 
-        this.temperatureMap = new FractalNoise3D<>(SimplexNoise.genOctaves(seed * 9871, 4));
-        this.humidityMap = new FractalNoise3D<>(SimplexNoise.genOctaves(seed * 39811, 4));
-        this.varietyMap = new FractalNoise3D<>(SimplexNoise.genOctaves(seed, 4));
-        this.noiseMap = new FractalNoise3D<>(SimplexNoise.genOctaves(seed * 543321, 2));
+        this.temperatureMap = new FractalNoise2D<>(SimplexNoise.genOctaves(seed * 9871, 4));
+        this.humidityMap = new FractalNoise2D<>(SimplexNoise.genOctaves(seed * 39811, 4));
+        this.varietyMap = new FractalNoise2D<>(SimplexNoise.genOctaves(seed, 4));
+        this.noiseMap = new FractalNoise2D<>(SimplexNoise.genOctaves(seed * 543321, 2));
     }
 
     public BiomeProviderOverworld withTemperatureScales(double xScale, double zScale, double lacunarity, double noise)
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
index 23e4b195a..3bb495e7c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
@@ -8,6 +8,7 @@ import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
 import net.minecraft.core.world.noise.*;
+import net.minecraft.core.world.noise.operator.Normalize2D;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.type.WorldType;
 import org.jetbrains.annotations.NotNull;
@@ -18,15 +19,23 @@ import java.util.Random;
 
 public class IceFloeLargeFeature
     extends LargeFeature {
-    private @Nullable Noise2D noise = null;
+    private @Nullable WorleyNoise chunkNoise = null;
+    private @Nullable Noise2D gapNoise = null;
     private @Nullable Noise2D scaleNoise = null;
     private @Nullable World lastWorld = null;
 
     @Override
-    protected void doGeneration(@NotNull final World world, @NotNull final Random random, final int chunkX, final int chunkZ, final int baseChunkX, final int baseChunkZ, @NotNull final ChunkGeneratorResult result) {
-        if (this.noise == null || this.scaleNoise == null || this.lastWorld != world) {
-            this.noise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4));
-            this.scaleNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 2));
+    protected void doGeneration(
+        @NotNull final World world,
+        @NotNull final Random random,
+        final int chunkX, final int chunkZ,
+        final int baseChunkX, final int baseChunkZ,
+        @NotNull final ChunkGeneratorResult result
+    ) {
+        if (this.chunkNoise == null || this.gapNoise == null || this.scaleNoise == null || this.lastWorld != world) {
+            this.chunkNoise = new WorleyNoise(new Random(world.getRandomSeed()));
+            this.gapNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4));
+            this.scaleNoise = new Normalize2D<>(new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 2)));
             this.lastWorld = world;
         }
 
@@ -34,8 +43,7 @@ public class IceFloeLargeFeature
         final int oceanY = worldType.getMinY() + worldType.getOceanY();
 
         final @NotNull TilePos tilePos = new TilePos();
-        final @NotNull Vector2f vec = new Vector2f();
-        final @NotNull WorleyNoise.Result worley = new WorleyNoise.Result();
+        final @NotNull WorleyNoise.Result worleyResult = new WorleyNoise.Result();
 
         for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
             for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
@@ -43,16 +51,16 @@ public class IceFloeLargeFeature
                 final @NotNull Biome biome = world.getBlockBiome(tilePos);
                 if (biome == Biomes.OVERWORLD_GLACIER) {
                     final float worleyScaleScale = 50.0f;
-
-                    // TODO: NORMALIZE THIS
-                    final float worleyScale = 0.875f + (float) (this.scaleNoise.getValue((baseChunkX * Chunk.CHUNK_SIZE_X + x) / worleyScaleScale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / worleyScaleScale)) * 0.25f;
-                    vec.x = (baseChunkX + ((float) x / (float) Chunk.CHUNK_SIZE_X)) * worleyScale;
-                    vec.y = (baseChunkZ + ((float) z / (float) Chunk.CHUNK_SIZE_Z)) * worleyScale;
-                    WorleyNoise.getWorleyDistance2d(vec, worley);
+                    final float worleyScale = 1.0f + (0.0625f - (float) (this.scaleNoise.getValue((baseChunkX * Chunk.CHUNK_SIZE_X + x) / worleyScaleScale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / worleyScaleScale))) * 0.125f;
+                    this.chunkNoise.getValue(
+                        (baseChunkX + ((float) x / (float) Chunk.CHUNK_SIZE_X)) * worleyScale,
+                        (baseChunkZ + ((float) z / (float) Chunk.CHUNK_SIZE_Z)) * worleyScale,
+                        worleyResult
+                    );
                     final float lineScale = 10.0f;
-                    final float lineWidth = (float) (this.noise.getValue((baseChunkX * Chunk.CHUNK_SIZE_X + x) / lineScale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / lineScale) / 2.0 + 0.5);
-                    if (MathHelper.unsignedMod(worley.index, 15) != 0) {
-                        if (worley.distance > 0.9f + lineWidth * 0.05f) {
+                    final float lineWidth = (float) (this.gapNoise.getValue((baseChunkX * Chunk.CHUNK_SIZE_X + x) / lineScale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / lineScale) / 2.0 + 0.5);
+                    if (MathHelper.unsignedMod(worleyResult.index, 15) != 0) {
+                        if (worleyResult.distance > 0.9f + lineWidth * 0.05f) {
                             continue;
                         }
                         for (int y = oceanY - 3; y < oceanY; y++) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/FractalNoise2D.java b/game/core/src/main/java/net/minecraft/core/world/noise/FractalNoise2D.java
index 9e86a5bb6..842460574 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/FractalNoise2D.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/FractalNoise2D.java
@@ -2,6 +2,8 @@ package net.minecraft.core.world.noise;
 
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2d;
+import org.joml.Vector2dc;
 
 public class FractalNoise2D<T extends Noise2D>
     implements Noise2D {
@@ -13,17 +15,43 @@ public class FractalNoise2D<T extends Noise2D>
     protected double lacunarity = DEFAULT_LACUNARITY;
     protected double persistence = DEFAULT_PERSISTENCE;
 
+    protected final @NotNull Vector2d range = new Vector2d();
+
     public FractalNoise2D(final @NotNull T @NotNull [] octaves) {
         this.octaves = octaves;
+
+        this.calculateRange();
+    }
+
+    private void calculateRange() {
+        final @NotNull Vector2dc innerRange = this.octaves[0].getRange2D();
+
+        double min = 0.0;
+        double max = 0.0;
+        double amplitude = 1.0;
+
+        for (int i = 0; i < this.octaves.length; i++) {
+            min += innerRange.x() * amplitude;
+            max += innerRange.y() * amplitude;
+            amplitude *= this.persistence;
+        }
+
+        this.range.set(min, max);
+    }
+
+    @Override
+    public @NotNull Vector2dc getRange2D() {
+        return this.range;
     }
 
-    public final @NotNull FractalNoise2D<T> setLacunarity(final double lacunarity) {
+    public @NotNull FractalNoise2D<T> setLacunarity(final double lacunarity) {
         this.lacunarity = lacunarity;
         return this;
     }
 
-    public final @NotNull FractalNoise2D<T> setPersistence(final double persistence) {
+    public @NotNull FractalNoise2D<T> setPersistence(final double persistence) {
         this.persistence = persistence;
+        this.calculateRange();
         return this;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/FractalNoise3D.java b/game/core/src/main/java/net/minecraft/core/world/noise/FractalNoise3D.java
index 65c2c7d0a..0f15bba96 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/FractalNoise3D.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/FractalNoise3D.java
@@ -2,13 +2,47 @@ package net.minecraft.core.world.noise;
 
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2d;
+import org.joml.Vector2dc;
 
 public class FractalNoise3D<T extends Noise3D>
     extends FractalNoise2D<T>
     implements Noise3D {
 
+    private final @NotNull Vector2d range = new Vector2d();
+
     public FractalNoise3D(final @NotNull T @NotNull [] octaves) {
         super(octaves);
+
+        this.calculateRange();
+    }
+
+    private void calculateRange() {
+        final @NotNull Vector2dc innerRange = this.octaves[0].getRange3D();
+
+        double min = 0.0;
+        double max = 0.0;
+        double amplitude = 1.0;
+
+        for (int i = 0; i < this.octaves.length; i++) {
+            min += innerRange.x() * amplitude;
+            max += innerRange.y() * amplitude;
+            amplitude *= this.persistence;
+        }
+
+        this.range.set(min, max);
+    }
+
+    @Override
+    public @NotNull Vector2dc getRange3D() {
+        return this.range;
+    }
+
+    @Override
+    public @NotNull FractalNoise2D<T> setPersistence(final double persistence) {
+        super.setPersistence(persistence);
+        this.calculateRange();
+        return this;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedPerlinNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedPerlinNoise.java
index c46674408..954c6128b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedPerlinNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedPerlinNoise.java
@@ -2,7 +2,10 @@ package net.minecraft.core.world.noise;
 
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2d;
+import org.joml.Vector2dc;
 
+import java.util.Arrays;
 import java.util.Random;
 
 // Derived from Ken Perlin's Improved Noise reference implementation: https://cs.nyu.edu/~perlin/noise/
@@ -51,12 +54,13 @@ public class ImprovedPerlinNoise
         }
     }
 
+    private static final @NotNull Vector2dc RANGE = new Vector2d(-Math.sqrt(3.0 / 4.0), Math.sqrt(3.0 / 4.0));
+
     private final @NotNull LegacyNoiseType legacyNoiseType;
 
     private final int @NotNull [] p;
     public final double xo;
     public final double yo;
-
     public final double zo;
 
     public ImprovedPerlinNoise(final @NotNull Random random) {
@@ -86,6 +90,16 @@ public class ImprovedPerlinNoise
         }
     }
 
+    @Override
+    public @NotNull Vector2dc getRange2D() {
+        return RANGE;
+    }
+
+    @Override
+    public @NotNull Vector2dc getRange3D() {
+        return RANGE;
+    }
+
     @Override
     public double getValue(final double x, final double z) {
         return this.getValue(x, z, 0);
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/Noise2D.java b/game/core/src/main/java/net/minecraft/core/world/noise/Noise2D.java
index ff74b3833..fc86587f3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/Noise2D.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/Noise2D.java
@@ -2,10 +2,14 @@ package net.minecraft.core.world.noise;
 
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2d;
+import org.joml.Vector2dc;
 
 import java.util.Arrays;
 
 public interface Noise2D {
+    @NotNull Vector2dc getRange2D();
+
     double getValue(final double x, final double z);
 
     double @NotNull [] addRegion(
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/Noise3D.java b/game/core/src/main/java/net/minecraft/core/world/noise/Noise3D.java
index 94e3d969a..ea9a7a74b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/Noise3D.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/Noise3D.java
@@ -2,11 +2,15 @@ package net.minecraft.core.world.noise;
 
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2d;
+import org.joml.Vector2dc;
 
 import java.util.Arrays;
 
 public interface Noise3D
     extends Noise2D {
+    @NotNull Vector2dc getRange3D();
+
     double getValue(final double x, final double y, final double z);
 
     double @NotNull [] addRegion(
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java
index cd5dacad0..c4a1dc1ba 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java
@@ -2,6 +2,8 @@ package net.minecraft.core.world.noise;
 
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2d;
+import org.joml.Vector2dc;
 
 import java.util.Random;
 
@@ -44,6 +46,8 @@ public class SimplexNoise
     private static final double F3 = 1.0 / 3.0;
     private static final double G3 = 1.0 / 6.0;
 
+    private static final @NotNull Vector2dc RANGE = new Vector2d(-1.0, 1.0);
+
     private final int @NotNull [] p;
     public final double xo;
     public final double yo;
@@ -68,6 +72,16 @@ public class SimplexNoise
         }
     }
 
+    @Override
+    public @NotNull Vector2dc getRange2D() {
+        return RANGE;
+    }
+
+    @Override
+    public @NotNull Vector2dc getRange3D() {
+        return RANGE;
+    }
+
     private static int fastFloor(final double d) {
         return d <= 0.0D ? (int) d - 1 : (int) d;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/WorleyNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/WorleyNoise.java
index 073ab4987..08be1ac72 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/WorleyNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/WorleyNoise.java
@@ -2,68 +2,156 @@ package net.minecraft.core.world.noise;
 
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
-import org.joml.Vector2f;
-import org.joml.Vector2fc;
-import org.joml.Vector3f;
-import org.joml.Vector3fc;
+import org.jetbrains.annotations.Nullable;
+import org.joml.*;
+
+import java.lang.Math;
+import java.util.Random;
 
 // NOTE: code shamelessly stolen from https://www.shadertoy.com/view/MslGD8,
 // https://www.reddit.com/r/proceduralgeneration/comments/4u0s1i/infinite_worleycellularvoroni_noise/,
 // and https://www.shadertoy.com/view/ldl3W8
-public final class WorleyNoise {
+public class WorleyNoise
+    implements Noise3D {
+    public static @NotNull WorleyNoise @NotNull [] genOctaves(final long seed, final int numOctaves) {
+        return genOctaves(seed, numOctaves, 0);
+    }
+
+    public static @NotNull WorleyNoise @NotNull [] genOctaves(final long seed, final int numOctaves, final int preOctaves) {
+        final @NotNull Random random = new Random(seed);
+
+        for (int i = 0; i < preOctaves; i++) {
+            random.nextDouble();
+            random.nextDouble();
+            random.nextDouble();
+
+            for (int j = 0; j < 256; j++) {
+                random.nextInt(256 - j);
+            }
+        }
+
+        final @NotNull WorleyNoise @NotNull [] octaves = new WorleyNoise[numOctaves];
+        for (int i = 0; i < numOctaves; i++) {
+            octaves[i] = new WorleyNoise(random);
+        }
+
+        return octaves;
+    }
+
     public static class Result {
-        public float distance;
+        public double distance;
         public int index;
     }
-    private WorleyNoise() { }
-
-    private static final @NotNull Vector2fc HASH_CONST_2D_A = new Vector2f(127.1f, 311.7f);
-    private static final @NotNull Vector2fc HASH_CONST_2D_B = new Vector2f(269.5f, 183.3f);
-    private static final @NotNull Vector3fc HASH_CONST_3D_A = new Vector3f(127.1f, 311.7f, 74.7f);
-    private static final @NotNull Vector3fc HASH_CONST_3D_B = new Vector3f(269.5f ,183.3f ,246.1f);
-    private static final @NotNull Vector3fc HASH_CONST_3D_C = new Vector3f(113.5f, 271.9f, 124.6f);
-    private static final float HASH_CONST_MULT = 18.5453f;
-
-    public static void getWorleyDistance2d(final @NotNull Vector2fc xy, final @NotNull Result result) {
-        final @NotNull Vector2fc ip = xy.floor(new Vector2f()); // nearest gridpoint
-        final @NotNull Vector2fc fp = xy.sub(ip, new Vector2f()); // fractional distance from gridpoint
-
-        final @NotNull Vector2f mg = new Vector2f();
-        final @NotNull Vector2f mr = new Vector2f();
-        float md = 8.0f;
+
+    private static final @NotNull Vector2dc RANGE = new Vector2d(0.5, 1.0);
+    private static final @NotNull Result DUMMY = new Result();
+
+    private final int @NotNull [] p;
+    private final double @NotNull [] @NotNull [] jitter;
+    public final double xo;
+    public final double yo;
+    public final double zo;
+
+    public WorleyNoise(final @NotNull Random random) {
+        this.p = new int[512];
+        this.xo = random.nextDouble() * 256;
+        this.yo = random.nextDouble() * 256;
+        this.zo = random.nextDouble() * 256;
+
+        // Assign initial values for each permutation
+        for (int i = 0; i < 256; i++) {
+            this.p[i] = i;
+        }
+
+        // Shuffle values
+        for (int i = 0; i < 256; i++) {
+            final int newI = random.nextInt(256 - i) + i;
+            final int temp = this.p[i];
+            this.p[i] = this.p[newI];
+            this.p[newI] = temp;
+            this.p[i + 256] = this.p[i];
+        }
+
+        this.jitter = new double[256][3];
+        for (int i = 0; i < 256; i++) {
+            this.jitter[i][0] = random.nextDouble();
+            this.jitter[i][1] = random.nextDouble();
+            this.jitter[i][2] = random.nextDouble();
+        }
+    }
+
+    @Override
+    public @NotNull Vector2dc getRange2D() {
+        return RANGE;
+    }
+
+    @Override
+    public @NotNull Vector2dc getRange3D() {
+        return RANGE;
+    }
+
+    public void getValue(final double x, final double z, final @NotNull Result result) {
+        final @NotNull Vector2dc ip = new Vector2d(x, z).floor();
+        final @NotNull Vector2dc fp = new Vector2d(x - ip.x(), z - ip.y());
+
+        final @NotNull Vector2d mg = new Vector2d();
+        final @NotNull Vector2d mr = new Vector2d();
+        double md = Double.POSITIVE_INFINITY;
+
         int index = 0;
 
-        final @NotNull Vector2f g = new Vector2f();
-        final @NotNull Vector2f o = new Vector2f();
-        final @NotNull Vector2f r = new Vector2f();
-        final @NotNull Vector2f pos = new Vector2f();
+        final @NotNull Vector2d g = new Vector2d();
+        final @NotNull Vector2d o = new Vector2d();
+        final @NotNull Vector2d r = new Vector2d();
+        final @NotNull Vector2d pos = new Vector2d();
 
         // First pass - regular voronoi
         for (int i = -1; i <= 1; i++) {
             for (int j = -1; j <= 1; j++) {
                 g.set(i, j);
-                hash(ip.add(g, pos), o); // o gives the offset of the gridpoint to use for lookup
-                g.add(o, r).sub(fp); // r gives distance to the point of interest in either direction
-                final float d = r.dot(r); // distance to gridpoint
-                if (d < md) { // check if this is the closest point
-                    md = d; // if it is, save the distance
+
+                // o gives the offset of the gridpoint to use for lookup
+                final int h = this.hash((int) ip.x() + (int) Math.floor(g.x), (int) ip.y() + (int) Math.floor(g.y));
+                o.set(
+                    this.jitter[h & 255][0],
+                    this.jitter[h & 255][1]
+                );
+
+                // r gives the distance to the point of interest in either direction
+                g.add(o, r).sub(fp);
+
+                // distance to gridpoint
+                final double d = r.dot(r);
+
+                // check if this is the closest point
+                if (d < md) {
+                    md = d;
                     mr.set(r);
                     mg.set(g);
-                    index = (int) (o.x * 10.0f) + (int) (o.y * 10.0f);
+                    index = (int) (o.x * 10.0) + (int) (o.y * 10.0);
                 }
             }
         }
 
         // Second pass - distance to borders
-        md = 8.0f;
+        md = Double.POSITIVE_INFINITY;
         for (int i = -2; i <= 2; i++) {
             for (int j = -2; j <= 2; j++) {
                 g.set(mg).add(i, j);
-                ip.add(g, pos);
-                hash(ip.add(g, pos), o);
-                g.add(o, r).sub(fp); // r gives distance to the point of interest in either direction
+
+                // o gives the offset of the gridpoint to use for lookup
+                final int h = this.hash((int) ip.x() + (int) Math.floor(g.x), (int) ip.y() + (int) Math.floor(g.y));
+                o.set(
+                    this.jitter[h & 255][0],
+                    this.jitter[h & 255][1]
+                );
+
+                // r gives the distance to the point of interest in either direction
+                g.add(o, r).sub(fp);
+
                 pos.set(mr).sub(r);
-                if (pos.dot(pos) > 0.00001f) {
+
+                if (pos.dot(pos) > 0.00001) {
                     g.set(mr).add(r).mul(0.5f);
                     o.set(r).sub(mr).normalize();
                     md = Math.min(md, g.dot(o));
@@ -71,53 +159,110 @@ public final class WorleyNoise {
             }
         }
 
-        result.distance = 1.0f - md;
+        result.distance = 1.0 - md;
         result.index = index;
     }
 
-    public static void getWorleyDistance3d(final @NotNull Vector3fc xyz, final @NotNull Result result) {
-        final @NotNull Vector3fc ip = xyz.floor(new Vector3f());
-        final @NotNull Vector3fc fp = xyz.sub(ip, new Vector3f());
+    @Override
+    public double getValue(final double x, final double z) {
+        this.getValue(x, z, DUMMY);
+        return DUMMY.distance;
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        double @Nullable [] out,
+        final double x, final double z,
+        final int xSize, final int zSize,
+        final double xScale, final double zScale,
+        final double amplitude
+    ) {
+        if (out == null || out.length != xSize * zSize) {
+            out = new double[xSize * zSize];
+        }
+
+        int i = 0;
+        for (int xi = 0; xi < xSize; xi++) {
+            final double xx = (x + xi) * xScale + this.xo;
+
+            for (int zi = 0; zi < zSize; zi++) {
+                final double zz = (z + zi) * zScale + this.zo;
+
+                out[i++] += this.getValue(xx, zz) * amplitude;
+            }
+        }
+
+        return out;
+    }
+
+    @Override
+    public double getValue(final double x, final double y, final double z) {
+        final @NotNull Vector3dc ip = new Vector3d(x, y, z).floor();
+        final @NotNull Vector3dc fp = new Vector3d(x - ip.x(), y - ip.y(), z - ip.z());
+
+        final @NotNull Vector3d mg = new Vector3d();
+        final @NotNull Vector3d mr = new Vector3d();
+        double md = 8.0;
 
-        final @NotNull Vector3f mg = new Vector3f();
-        final @NotNull Vector3f mr = new Vector3f();
-        float md = 8.0f;
         int index = 0;
 
-        final @NotNull Vector3f g = new Vector3f();
-        final @NotNull Vector3f o = new Vector3f();
-        final @NotNull Vector3f r = new Vector3f();
-        final @NotNull Vector3f pos = new Vector3f();
+        final @NotNull Vector3d g = new Vector3d();
+        final @NotNull Vector3d o = new Vector3d();
+        final @NotNull Vector3d r = new Vector3d();
+        final @NotNull Vector3d pos = new Vector3d();
 
         // First pass - regular voronoi
         for (int i = -1; i <= 1; i++) {
             for (int j = -1; j <= 1; j++) {
                 for (int k = -1; k <= 1; k++) {
                     g.set(i, j, k);
-                    hash(ip.add(g, pos), o); // o gives the offset of the gridpoint to use for lookup
-                    g.add(o, r).sub(fp); // r gives distance to the point of interest in either direction
-                    final float d = r.dot(r); // distance to gridpoint
-                    if (d < md) { // check if this is the closest point
-                        md = d; // if it is, save the distance
+
+                    // o gives the offset of the gridpoint to use for lookup
+                    final int h = this.hash((int) ip.x() + i, (int) ip.y() + j, (int) ip.z() + k);
+                    o.set(
+                        this.jitter[h & 255][0],
+                        this.jitter[h & 255][1],
+                        this.jitter[h & 255][2]
+                    );
+
+                    // r gives the distance to the point of interest in either direction
+                    g.add(o, r).sub(fp);
+
+                    // distance to gridpoint
+                    final double d = r.dot(r);
+
+                    // check if this is the closest point
+                    if (d < md) {
+                        md = d;
                         mr.set(r);
                         mg.set(g);
-                        index = (int) (o.x * 10.0f) + (int) (o.y * 10.0f) + (int) (o.z * 10.0f);
+                        index = (int) (o.x * 10.0) + (int) (o.y * 10.0) + (int) (o.z * 10.0);
                     }
                 }
             }
         }
 
         // Second pass - distance to borders
-        md = 8.0f;
+        md = 8.0;
         for (int i = -2; i <= 2; i++) {
             for (int j = -2; j <= 2; j++) {
                 for (int k = -2; k <= 2; k++) {
                     g.set(mg).add(i, j, k);
-                    ip.add(g, pos);
-                    hash(ip.add(g, pos), o);
-                    g.add(o, r).sub(fp); // r gives distance to the point of interest in either direction
+
+                    // o gives the offset of the gridpoint to use for lookup
+                    final int h = this.hash((int) ip.x() + i, (int) ip.y() + j, (int) ip.z() + k);
+                    o.set(
+                        this.jitter[h & 255][0],
+                        this.jitter[h & 255][1],
+                        this.jitter[h & 255][2]
+                    );
+
+                    // r gives the distance to the point of interest in either direction
+                    g.add(o, r).sub(fp);
+
                     pos.set(mr).sub(r);
-                    if (pos.dot(pos) > 0.00001f) {
+
+                    if (pos.dot(pos) > 0.00001) {
                         g.set(mr).add(r).mul(0.5f);
                         o.set(r).sub(mr).normalize();
                         md = Math.min(md, g.dot(o));
@@ -126,48 +271,44 @@ public final class WorleyNoise {
             }
         }
 
-        result.distance = 1.0f - md;
-        result.index = index;
+        return 1.0 - md;
     }
 
-    private static void hash(final @NotNull Vector2fc p, final @NotNull Vector2f out) {
-        out.x = p.dot(HASH_CONST_2D_A);
-        out.y = p.dot(HASH_CONST_2D_B);
+    @Override
+    public double @NotNull [] addRegion(
+        double @Nullable [] out,
+        final double x, final double y, final double z,
+        final int xSize, final int ySize, final int zSize,
+        final double xScale, final double yScale, final double zScale,
+        final double amplitude
+    ) {
+        if (out == null || out.length != xSize * zSize) {
+            out = new double[xSize * zSize];
+        }
 
-        sin(out, out);
-        out.mul(HASH_CONST_MULT, out);
-        fract(out, out);
-    }
+        int i = 0;
+        for (int xi = 0; xi < xSize; xi++) {
+            final double xx = (x + xi) * xScale + this.xo;
 
-    private static void hash(final @NotNull Vector3fc p, final @NotNull Vector3f out) {
-        out.x = p.dot(HASH_CONST_3D_A);
-        out.y = p.dot(HASH_CONST_3D_B);
-        out.z = p.dot(HASH_CONST_3D_C);
+            for (int zi = 0; zi < zSize; zi++) {
+                final double zz = (z + zi) * zScale + this.zo;
 
-        sin(out, out);
-        out.mul(HASH_CONST_MULT, out);
-        fract(out, out);
-    }
+                for (int yi = 0; yi < ySize; yi++) {
+                    final double yy = (y + yi) * yScale + this.yo;
 
-    private static void sin(final @NotNull Vector2fc p, final @NotNull Vector2f out) {
-        out.x = (float) Math.sin(p.x());
-        out.y = (float) Math.sin(p.y());
-    }
+                    out[i++] += this.getValue(xx, yy, zz) * amplitude;
+                }
+            }
+        }
 
-    private static void sin(final @NotNull Vector3fc p, final @NotNull Vector3f out) {
-        out.x = (float) Math.sin(p.x());
-        out.y = (float) Math.sin(p.y());
-        out.z = (float) Math.sin(p.z());
+        return out;
     }
 
-    private static void fract(final @NotNull Vector2fc p, final @NotNull Vector2f out) {
-        out.x = p.x() - MathHelper.floor_float(p.x());
-        out.y = p.y() - MathHelper.floor_float(p.y());
+    private int hash(final int x, final int z) {
+        return this.p[(x + this.p[z & 255]) & 255];
     }
 
-    private static void fract(final @NotNull Vector3fc p, final @NotNull Vector3f out) {
-        out.x = p.x() - MathHelper.floor_float(p.x());
-        out.y = p.y() - MathHelper.floor_float(p.y());
-        out.z = p.z() - MathHelper.floor_float(p.z());
+    private int hash(final int x, final int y, final int z) {
+        return this.p[(x + this.p[(z + this.p[y & 255]) & 255]) & 255];
     }
 }
